C
C
C
C---- DINMOD.INC ------------------------------------------------------*
C
C  THIS FILE CONTAINS COMMON BLOCK ASSIGNMENTS FOR THE FESWMS DATA
C  INPUT MODULE-VERSION 1.10.DG2.  THE INSERT STATEMENT IS USED TO
C  INSERT THIS FILE AT THE BEGINNING OF ALL MAIN- AND SUB-PROGRAMS FOR
C  WHICH IT IS REQUIRED.
C
C----------------------------------------------------------------------*
C
C---- Declarations
      INTEGER   NOP,LMAT,ISEQ,LSEQ,LADJL,LOLD,LNEW,LNEXT,NOLAL,
     #          NPID,LADJN,NEIGH,NOLAN,LFRST,MSM,IES,LSIDE,LNGEN,NPOLY,
     #          IHOLD,LWAVE
      INTEGER   MAXP,MAXE,MAXS,MAXLW,MAXLIN
      CHARACTER VERSION*8
      CHARACTER JTITLE*80,PTITLE*80,ID*4
      CHARACTER*63 DATAFILE,GRDAFILE,GRDBFILE,PRNTFILE,PLOTFILE
      LOGICAL   WIDE,SCREEN
C
C---- Common blocks
      COMMON /BLKA/
     # IPRNT,IPLOT,ICHEK,IAUTO,IRESQ,IGOUT,IWSTYP,
     # NXZL,NRFN,NGEN,
     # NRSQ,IRSQ(10),MHLD(10),LRSQ(10,56),IREFN,
     # NP,NE,NMSN,IO1,IO2,IO3,LDEV,OMEGA,
     # WIDE,SCREEN,VERSION
      COMMON /BLKB/
     # IPLTN,IPLTE,HTT,HTN,HTE,HTC,CVINC,
     # XL,YL,XU,YU,XSCALE,YSCALE,AROT,COSA,SINA,
     # XLOP,YLOP,XHIP,YHIP,XLP,YLP,XUP,YUP,CVMIN,CVMAX
      COMMON /BLKC/
     # JTITLE,PTITLE,ID(10),
     # DATAFILE,GRDAFILE,GRDBFILE,PRNTFILE,PLOTFILE
      COMMON /BLKT/ WAITT(7),DNAT(6,7),DNBT(6,7)
      COMMON /BLKR/ WAITR(9),DNAR(8,9),DNBR(8,9),DNAR9(9,9),DNBR9(9,9)
      COMMON /BLKNL/NODE(9)
C
C---- Parameters
      PARAMETER(MAXP   = 40000)
      PARAMETER(MAXE   = 10000)
      PARAMETER(MAXS   = 30000)
      PARAMETER(MAXLW  =  5000)
      PARAMETER(MAXLIN =  1500)
C
C  Note - MAXS >= 3*MAXE
C         MAXP >= 4*MAXE
C
C---- The following arrays are dimensioned for the maximum allowable
C     number of elements (MAXE) as follows:
C
C     NOP(MAXE,9)......Element connectivity lists
C     LMAT(MAXE).......Element type codes
C     ISEQ(MAXE).......Ith element to be assembled
C     LSEQ(MAXE).......Assembly sequence of the ith element
C     LADJL(MAXE,20)...List of elements adjacent to an element
C     LOLD(MAXE).......Old element assembly sequence
C     LNEW(MAXE).......New element assembly sequence
C     LNEXT(MAXE)......Number of unassembled elements next to an element
C
      COMMON /BLKL1/NOP(MAXE,9)
      COMMON /BLKL2/LMAT(MAXE)
      COMMON /BLKL3/ISEQ(MAXE)
      COMMON /BLKL4/LSEQ(MAXE)
      COMMON /BLKL6/LADJL(MAXE,20)
      COMMON /BLKL7/LOLD(MAXE)
      COMMON /BLKL8/LNEW(MAXE)
      COMMON /BLKL9/LNEXT(MAXE)
      COMMON /BLKL0/NOLAL(MAXE)
      COMMON /BLKF/ LWAVE(MAXE),IHOLD(MAXE)
      COMMON /BLKP1/LNGEN(MAXE)
      COMMON /BLKP2/NPOLY(MAXE)
C
C---- The following arrays are dimensioned for the maximum allowable
C     number of nodes (MAXP) as follows:
C
C     CORD(MAXP,2).....Node point coordinates
C     GRND(MAXP).......Node point ground elevations
C     CEIL(MAXP).......Node point ceiling elevations
C     NPID(MAXP).......Node point identification code
C     LADJN(MAXP,10)...List of elements adjacent to a node
C     NEIGH(MAXP)......Number of unresquenced elements adjacent to a node
C     NOLAN(MAXP)......Number of elements adjacent to a node
C     LFRST(MAXP)......Number of elements making their first appearance
C
      COMMON /BLKN1/CORD(MAXP,2)
      COMMON /BLKN2/GRND(MAXP)
      COMMON /BLKN3/CEIL(MAXP)
      COMMON /BLKN4/NPID(MAXP)
      COMMON /BLKN5/LADJN(MAXP,10)
      COMMON /BLKN6/NEIGH(MAXP)
      COMMON /BLKN7/NOLAN(MAXP)
      COMMON /BLKN8/LFRST(MAXP)
C
C---- The following arrays are dimensioned for the maximum allowable
C     number of element sides (MAXS) as follows:
C
C     MSN(MAXS)........Midside node numbers
C     IES(MAXS,3)......Element side nodes list
C     LSIDE(MAXS)......Element side code
C
      COMMON /BLKM/ MSN(MAXS)
      COMMON /BLKG1/IES(MAXS,3)
      COMMON /BLKG2/LSIDE(MAXS)
C
C
      COMMON /BLKNX/LINE(MAXLIN)
