C
C
C
      SUBROUTINE TIMER(TIME)
C
C---- TIMER ----------------------------------------------------------S
C
C  PURPOSE:
C    RETRIEVES THE CURRENT TIME OF DAY IN A CHARACTER STRING. A SYSTEM
C    SUBROUTINE MUST BE CALLED TO SUPPLY THE TIME OF DAY.
C
C  OUTPUT ARGUMENT(S):
C    TIME   - A CHARACTER STRING CONTAINING THE TIME OF DAY IN THE
C             FORM HH:MM:SS.
C
C---------------------------------------------------------------------F
C
C---- Declarations (arguments)
      CHARACTER TIME*(*)
C
C---- Declarations (local)
      INTEGER*2 IHR,IMIN,ISEC,IHUN
      INTEGER   NCHAR
      CHARACTER STRING*80
C
C---- REPLACE THE FOLLOWING STATEMENT WITH CODE FOR A PARTICULAR SYSTEM
      TIME='HH:MM:SS'
C
C---- THE FOLLOWING CODE IS FOR MS-DOS
cc    TIME='  :  :  '
cc    CALL GETTIM(IHR,IMIN,ISEC,IHUN)
cc    WRITE(TIME(1:2),'(I2)') IHR
cc    WRITE(TIME(4:5),'(I2)') IMIN
cc    WRITE(TIME(7:8),'(I2)') ISEC
C
C---- THE FOLLOWING CODE IS FOR PRIMOS
CX    CALL=TIME$A(TIME)
C
      RETURN
      END
C
C
C
      SUBROUTINE DATER(DATE)
C
C---- DATER ----------------------------------------------------------S
C
C  PURPOSE:
C    RETRIEVES THE CURRENT DATE IN A CHARACTER STRING.  A SYSTEM
C    SUBROUTINE MUST BE CALLED TO SUPPLY THE DATE IN THE CORRECT
C    FORM.
C
C  OUTPUT ARGUMENT(S):
C    DATE   - CHARACTER STRING CONTAINING THE DATE IN THE FORM
C             MM/DD/YY
C
C---------------------------------------------------------------------F
C
C---- Declarations (arguments)
      CHARACTER DATE*(*)
C
C---- Declarations (local)
      INTEGER*2 IYR,IMON,IDAY
      INTEGER   NCHAR
      CHARACTER STRING*80
C
C---- REPLACE THE FOLLOWING STATEMENT WITH CODE FOR A PARTICULAR SYSTEM
      DATE='MM/DD/YY'
C
C---- THE FOLLOWING CODE IS FOR MS-DOS
cc    DATE='  /  /          '
cc    CALL GETDAT(IYR,IMON,IDAY)
cc    WRITE(DATE(1:2),'(I2)') IMON
cc    WRITE(DATE(4:5),'(I2)') IDAY
cc    WRITE(DATE(7:8),'(I2)') MOD(IYR,100)
C
C-----THE FOLLOWING IS CODE FOR PRIMOS
cx    CALL DATE$A(DATE)
      RETURN
      END
C
C
C
      SUBROUTINE PRESS RETURN
C
C---- PRESS RETURN ----------------------------------------------------S
C
C  PURPOSE:
C    Writes "Press <RETURN> to continue..." to the screen and waits
C    for <RETURN> to be pressed before continuing.
C
C----------------------------------------------------------------------F
C
C---- Declarations (local)
      CHARACTER RETURN*3,STRING*80
C
C---- Output formats
2000  FORMAT(' Press ',(A),' to continue...')
C
      RETURN(1:1)=CHAR(17)
      RETURN(2:2)=CHAR(196)
      RETURN(3:3)=CHAR(217)
      WRITE(*,2000) RETURN
      READ(*,'(A)') STRING
      RETURN
      END
C
C
C
      SUBROUTINE BEEP
C
C---- BEEP ------------------------------------------------------------S
C
C  PURPOSE:
C    SOUNDS THE TERMINAL SPEAKER.
C
C----------------------------------------------------------------------F
C
C-----OUTPUT FORMATS
2000  FORMAT(1H+,A)
C
      WRITE(*,2000) CHAR(7)
      RETURN
      END
C
C
C
      SUBROUTINE BEEPS(N)
C
C---- BEEPS -----------------------------------------------------------S
C
C  PURPOSE:
C    SOUNDS THE TERMINAL SPEAKER THE SPECIFIED NUMBER OF TIMES.
C
C  INPUT ARGUMENT(S):
C    N      - NUMBER OF TIMES THE TERMINAL SPEAKER IS TO BE SOUNDED.
C
C  SUBPROGRAM(S) CALLED:
C    BEEP
C
C----------------------------------------------------------------------F
C
C---- Declarations (arguments)
      INTEGER   N
C
C---- Declarations (local)
      INTEGER   I
C
      DO 10 I=1,N
        CALL BEEP
10    CONTINUE
      RETURN
      END
C
C
C
      LOGICAL FUNCTION EXISTS(FILENAME)
C
C---- EXISTS ----------------------------------------------------------S
C
C  PURPOSE:
C    DETERMINES WHETHER OR NOT A FILE EXISTS.
C
C  INPUT ARGUMENT(S):
C    FILENAME - NAME OF THE FILE.
C
C----------------------------------------------------------------------F
C
C---- Declarations (arguments)
      CHARACTER FILENAME*(*)
C
      INQUIRE(FILE=FILENAME,EXIST=EXISTS)
      RETURN
      END
C
C
C
      INTEGER FUNCTION LENCHR(STRING)
C
C---- LENCHR ----------------------------------------------------------S
C
C  PURPOSE:
C    DETERMINES THE LENGTH OF A CHARACTER STRING.
C
C  INPUT ARGUMENT(S):
C    STRING - CHARACTER STRING
C
C----------------------------------------------------------------------F
C
C---- Declarations (arguments)
      CHARACTER STRING*(*)
C
C---- Declarations (local)
      INTEGER   I,IHI
C
      LENCHR=0
      IHI=LEN(STRING)
      DO 10 I=IHI,1,-1
        IF(STRING(I:I).NE.' ') THEN
          LENCHR=I
          RETURN
        ENDIF
10    CONTINUE
      RETURN
      END
C
C
C
      SUBROUTINE CHAR2I(STRING,VALUE,ERR)
C
C---- CHAR2I ----------------------------------------------------------S
C
C  PURPOSE:
C    CONVERTS A CHARACTER REPRESENTAION OF AN INTEGER TO ITS NUMERIC
C    VALUE.
C
C  INPUT ARGUMENT(S):
C    STRING - CHARACTER REPRESENTATION OF THE INTEGER.
C
C  OUTPUT ARGUMENT(S):
C    VALUE  - NUMERIC VALUE OF THE INTEGER REPRESENTED BY STRING.
C    ERR    - LOGICAL ERROR CODE.  ERR IS TRUE IF THE CHARACTER DOES
C             NOT REPRESENT AN INTEGER.
C
C----------------------------------------------------------------------F
C
C---- Declarations (arguments)
      INTEGER   VALUE
      CHARACTER STRING*(*)
      LOGICAL   ERR
C
C---- Declarations (local values)
      INTEGER   DIGIT,SIGN,MINUS,PLUS,SPACE,ZERO,NINE,I,IHI
C
      VALUE=0
      ERR=.FALSE.
      SIGN=1
      MINUS=ICHAR('-')
      PLUS=ICHAR('+')
      SPACE=ICHAR(' ')
      ZERO=ICHAR('0')
      NINE=ICHAR('9')
      IHI=LEN(STRING)
      DO 10 I=1,IHI
        IF(ICHAR(STRING(I:I)).GT.SPACE) GOTO 20
10    CONTINUE
      ERR=.TRUE.
      GOTO 999
20    DIGIT=ICHAR(STRING(I:I))
      IF(DIGIT.EQ.PLUS) THEN
        SIGN=1
      ELSEIF(DIGIT.EQ.MINUS) THEN
        SIGN=-1
      ELSEIF(DIGIT.GE.ZERO .AND. DIGIT.LE.NINE) THEN
        VALUE=DIGIT-ZERO
      ELSE
        ERR=.TRUE.
        GOTO 999
      ENDIF
30    I=I+1
      DIGIT=ICHAR(STRING(I:I))
      IF(DIGIT.EQ.SPACE) THEN
        GOTO 40
      ELSEIF(DIGIT.GE.ZERO .AND. DIGIT.LE.NINE) THEN
        VALUE=10*VALUE+DIGIT-ZERO
      ELSE
        ERR=.TRUE.
        GOTO 999
      ENDIF
      GOTO 30
40    VALUE=SIGN*VALUE
999   RETURN
      END
C
C
C
      SUBROUTINE CHAR2R(STRING,VALUE,ERR)
C
C---- CHAR2R ----------------------------------------------------------S
C
C  PURPOSE:
C    CONVERTS A CHARACTER REPRESENTAION OF AN REAL NUMBER TO ITS
C    NUMBERIC VALUE.
C
C  INPUT ARGUMENT(S):
C    STRING - CHARACTER REPRESENTATION OF THE INTEGER.
C
C  OUTPUT ARGUMENT(S):
C    VALUE  - NUMERIC VALUE OF THE REAL NUMBER REPRESENTED BY STRING.
C    ERR    - LOGICAL ERROR CODE SET TRUE IF AN INVALID CHARACTER IS
C             ENCOUNTERED IN THE STRING.
C
C----------------------------------------------------------------------F
C
C---- Decalarations (arguments)
      REAL      VALUE
      CHARACTER STRING*(*)
      LOGICAL   ERR
C
C---- Declarations (local values)
      INTEGER   DIGIT,MINUS,PLUS,SPACE,ZERO,NINE,POINT,I,IHI
      REAL      FACTOR
      LOGICAL   DECPT
C
C-----ASSIGN VALUES
      VALUE=0.
      ERR=.FALSE.
      DECPT=.FALSE.
      SIGN=1.
      FACTOR=0.1
      MINUS=ICHAR('-')
      POINT=ICHAR('.')
      PLUS=ICHAR('+')
      SPACE=ICHAR(' ')
      ZERO=ICHAR('0')
      NINE=ICHAR('9')
      IHI=LEN(STRING)
      DO 10 I=1,IHI
        IF(ICHAR(STRING(I:I)).GT.SPACE) GOTO 20
10    CONTINUE
      ERR=.TRUE.
      GOTO 999
20    DIGIT=ICHAR(STRING(I:I))
C
C-----DETERMINE SIGN
      IF(DIGIT.EQ.PLUS) THEN
        SIGN=1.
      ELSEIF(DIGIT.EQ.POINT) THEN
        SIGN=1.
        DECPT=.TRUE.
      ELSEIF(DIGIT.EQ.MINUS) THEN
        SIGN=-1.
      ELSEIF(DIGIT.GE.ZERO .AND. DIGIT.LE.NINE) THEN
        VALUE=REAL(DIGIT-ZERO)
      ELSE
        ERR=.TRUE.
        GOTO 999
      ENDIF
C
C-----CONVERT CHARACTERS TO DIGITS AND SUM
30    I=I+1
      DIGIT=ICHAR(STRING(I:I))
      IF(DIGIT.EQ.SPACE) GOTO 40
      IF(DIGIT.EQ.POINT) THEN
        IF(DECPT) THEN
          ERR=.TRUE.
          GOTO 999
        ELSE
          DECPT=.TRUE.
        ENDIF
      ELSEIF(DIGIT.GE.ZERO .AND. DIGIT.LE.NINE) THEN
        IF(DECPT) THEN
          VALUE=VALUE+FACTOR*REAL(DIGIT-ZERO)
          FACTOR=0.1*FACTOR
        ELSE
          VALUE=10.*VALUE+REAL(DIGIT-ZERO)
        ENDIF
      ELSE
        ERR=.TRUE.
        GOTO 999
      ENDIF
      GOTO 30
40    VALUE=SIGN*VALUE
999   RETURN
      END
C
C
C
      SUBROUTINE R2CHAR(FPN,NDEC,STRING,NCHAR)
C
C---- R2CHAR ----------------------------------------------------------S
C
C  PURPOSE:
C    CONVERTS A REAL NUMBER TO A CHARACTER STRING.
C
C  INPUT ARGUMENT(S):
C    FPN    - REAL NUMBER TO BE CONVERTED.
C    NDEC   - NUMBER OF DIGITS TO BE INCLUDED TO THE RIGHT OF THE
C             DECIMAL POINT.  IF < 0, THEN AN INTEGER IS RETURNED.
C
C  OUTPUT ARGUMENT(S):
C    STRING - CHARACTER STRING REPRESENTATION OF THE NUMBER.
C    NCHAR  - NUMBER OF CHARACTERS IN THE STRING.
C
C----------------------------------------------------------------------F
C
C---- Declarations (arguments)
      INTEGER   NDEC,NCHAR
      REAL      FPN
      CHARACTER STRING*(*)
C
C---- Declarations (local values)
      INTEGER   I,J,K,ILP,N,MAXN,MN,KK
      REAL      FPV
      CHARACTER MINUS,ZERO,POINT,NUM(80)
C
C---- Data
      DATA MINUS /'-'/,ZERO/'0'/,POINT/'.'/
C
      STRING=' '
      NCHAR=0
      FPV=FPN
      N=NDEC
      MAXN=9
      IF(N.GT.MAXN) N=MAXN
      IF(N+MAXN.LT.0) N=-MAXN
      IF(FPV.LT.0.) THEN
        NCHAR=NCHAR+1
        NUM(NCHAR)=MINUS
      ENDIF
      MN=-N
      IF(N.LT.0) MN=MN-1
      FPV=ABS(FPV)+(0.5*10.**MN)
      I=ALOG10(FPV)+1.0
      ILP=I
      IF(N.LT.-1) ILP=ILP+N+1
      IF(ILP.LE.0) THEN
        NCHAR=NCHAR+1
        NUM(NCHAR)=ZERO
      ELSE
        IF(ILP+N.GT.18) THEN
          N=-1
          IF(ILP.GT.19) ILP=19
        ENDIF
        DO 10 J=1,ILP
          K=FPV*10.**(J-I)
          IF(K.GT.9) K=9
          NCHAR=NCHAR+1
          KK=ICHAR(ZERO)+K
          NUM(NCHAR)=CHAR(KK)
          FPV=FPV-(FLOAT(K)*10.**(I-J))
10      CONTINUE
      ENDIF
      IF(N.GE.0) THEN
        NCHAR=NCHAR+1
        NUM(NCHAR)=POINT
        DO 20 J=1,N
          K=FPV*10.
          IF(K.GT.9) K=9
          NCHAR=NCHAR+1
          KK=ICHAR(ZERO)+K
          NUM(NCHAR)=CHAR(KK)
          FPV=FPV*10.-FLOAT(K)
20      CONTINUE
      ENDIF
      DO 30 I=1,NCHAR
        STRING(I:I)=NUM(I)
30    CONTINUE
      RETURN
      END
C
C
C
      SUBROUTINE GETCHR(PROMPT,STRING)
C
C---- GETCHR ----------------------------------------------------------S
C
C  PURPOSE:
C    WRITES A PROMPT ON THE SCREEN AND READS A CHARACTER STRING.
C
C  INPUT ARGUMENT(S):
C    PROMPT - PROMPT MESSAGE.
C
C  OUTPUT ARGUMENT(S):
C    STRING - CHARACTER STRING ENTERED AT THE KEYBOARD.
C
C  SUBPROGRAM(S) CALLED:
C    LENCHR
C
C----------------------------------------------------------------------F
C
      CHARACTER PROMPT*(*),STRING*(*)
      INTEGER   LENCHR
C
C-----OUTPUT FORMATS
2000  FORMAT(1X,(A),' ')
C
      STRING=' '
      WRITE(*,2000) PROMPT(1:LENCHR(PROMPT))
      READ(*,'(A)') STRING
      RETURN
      END
C
C
C
      SUBROUTINE GETI(I,ILO,IHI,PROMPT,ERR)
C
C---- GETI ------------------------------------------------------------S
C
C  PURPOSE:
C    PROMPTS THE USER FOR AND READS FROM THE KEYBOARD AN INTEGER VALUE.
C    THE VALUE IS CHECKED FOR VALIDITY AND RANGE.
C
C  INPUT ARGUMENT(S):
C    I      - DEFAULT VALUE.
C    ILO    - LOWEST ALLOWABLE VALUE.
C    IHI    - HIGHEST ALLOWABLE VALUE.
C    PROMPT - CHARACTER STRING USED TO PROMPT FOR THE VALUE.
C
C  OUTPUT ARGUMENT(S):
C    I      - INTEGER VALUE ENTERED AT THE KEYBOARD.
C    ERR    - LOGICAL ERROR CODE (TRUE IF ERROR ENCOUNTERED).
C
C  SUBPROGRAM(S) CALLED:
C    GETCHR, CHAR2I, BEEP
C
C----------------------------------------------------------------------F
C
C---- Declarations (arguments)
      INTEGER   I,ILO,IHI
      CHARACTER PROMPT*(*)
      LOGICAL   ERR
C---- Declarations (local values)
      INTEGER   ITEMP
      CHARACTER STRING*80
C
C-----OUTPUT FORMATS
2001  FORMAT(' ***Error - not an integer value.')
2003  FORMAT(' ***Error - value out of allowable range.')
C
C-----GET VALUE
      ERR=.FALSE.
      CALL GETCHR(PROMPT,STRING)
C
C-----ASSIGN DEFAULT IF STRING = ' '
      IF(STRING.EQ.' ') THEN
        ITEMP=I
C
C-----OTHERWISE CONVERT CHARACTER STRING TO AN INTEGER
      ELSE
        CALL CHAR2I(STRING,ITEMP,ERR)
      ENDIF
C
C-----WAS THE ENTERED VALUE AN INTEGER?
      IF(ERR) THEN
        WRITE(*,2001)
        CALL BEEP
C
C-----IS THE ENTERED VALUE WITHIN THE ALLOWABLE ALLOWABLE RANGE?
      ELSEIF(ITEMP.LT.ILO .OR. ITEMP.GT.IHI) THEN
        ERR=.TRUE.
        WRITE(*,2003)
        CALL BEEP
C
C-----ACCEPT THE ENTERED VALUE
      ELSE
        I=ITEMP
      ENDIF
      RETURN
      END
C
C
C
      SUBROUTINE GETR(R,RLO,RHI,PROMPT,ERR)
C
C---- GETR ------------------------------------------------------------S
C
C  PURPOSE:
C    PROMPTS THE USER FOR AND READS FROM THE KEYBOARD A REAL VALUE.
C    THE VALUE IS CHECKED FOR VALIDITY AND RANGE.
C
C  INPUT ARGUMENT(S):
C    R      - DEFAULT VALUE.
C    RLO    - LOWEST ALLOWABLE VALUE.
C    RHI    - HIGHEST ALLOWABLE VALUE.
C    PROMPT - CHARACTER STRING USED TO PROMPT FOR THE VALUE (MAXIMUM
C             80 CHARACTERS).
C
C  OUTPUT ARGUMENT(S):
C    R      - REAL VALUE ENTERED AT THE KEYBOARD.
C    ERR    - LOGICAL ERROR CODE (TRUE IF ERROR ENCOUNTERED)
C
C  SUBPROGRAM(S) CALLED:
C    GETCHR, CHAR2R, BEEP
C
C----------------------------------------------------------------------F
C
C---- Declarations (arguments)
      REAL      R,RLO,RHI
      CHARACTER PROMPT*(*)
      LOGICAL   ERR
C
C---- Declarations (local variables)
      REAL      RTEMP
      CHARACTER STRING*80
C
C-----OUTPUT FORMATS
2002  FORMAT(' ***Error - invalid character encountered.')
2003  FORMAT(' ***Error - value out of allowable range.')
C
C-----GET VALUE
      ERR=.FALSE.
      CALL GETCHR(PROMPT,STRING)
C
C-----ASSIGN DEFAULT IF STRING = ' '
      IF(STRING.EQ.' ') THEN
        RTEMP=R
C
C-----OTHERWISE CONVERT THE CHARACTER STRING TO A REAL VALUE
      ELSE
        CALL CHAR2R(STRING,RTEMP,ERR)
      ENDIF
C
C-----WAS THE ENTERED VALUE A REAL NUMBER?
      IF(ERR) THEN
        WRITE(*,2002)
        CALL BEEP
C
C-----WAS THE ENTERED VALUE WITHIN THE ALLOWABLE RANGE?
      ELSEIF(RTEMP.LT.RLO .OR. RTEMP.GT.RHI) THEN
        ERR=.TRUE.
        WRITE(*,2003)
        CALL BEEP
C
C-----ACCEPT THE ENTERED VALUE
      ELSE
        R=RTEMP
      ENDIF
      RETURN
      END
C
C
C
      SUBROUTINE SCRMES(STRING)
C
C---- SCRMES ----------------------------------------------------------S
C
C  PURPOSE:
C    PRINTS A MESSAGE ON THE SCREEN WITHOUT ADVANCING TO THE NEXT LINE.
C    THE LINE IS BLANKED BEFORE PRINTING THE MESSAGE.
C
C  INPUT ARGUMENT(S):
C    STRING - MESSAGE TO BE PRINTED ON THE SCREEN.
C
C----------------------------------------------------------------------F
C
C---- Declarations
      CHARACTER STRING*(*)
      INTEGER   LENCHR
C
      WRITE(*,'(1H+,79X/1H+,(A))') STRING(1:LENCHR(STRING))
      RETURN
      END
C
C
C
      SUBROUTINE SETUP
      INTEGER TEXTATTR,BG,FG,BGANSI,FGANSI
      LOGICAL EXIST
      DIMENSION BGANSI(8),FGANSI(8)
      DATA BGANSI/40,44,42,46,41,45,43,47/
      DATA FGANSI/30,34,32,36,31,35,33,37/
      INQUIRE(FILE='\FESWMS\SCREEN.COL',EXIST=EXIST)
      IF(EXIST) THEN
        OPEN(5,FILE='\FESWMS\SCREEN.COL')
        READ(5,*) TEXTATTR
        CLOSE(5)
        FG=MOD(TEXTATTR,16)
        BG=TEXTATTR/16
C------ Convert Pascal text attribute code to ANSI codes
        CALL SET ATTRIBUTE(BGANSI(BG+1))
        CALL SET ATTRIBUTE(FGANSI(MOD(FG,8)+1))
        IF(FG.GT.7) CALL SET ATTRIBUTE(1)
        CALL ERASE DISPLAY
      ENDIF
      RETURN
      END
C
C
C
      SUBROUTINE FORMFD(IUNIT)
C
C---- FORMFD ----------------------------------------------------------S
C
C  PURPOSE:
C    WRITES ASCII FORM FEED CHARACTER CODE TO THE SPECIFIED UNIT
C
C----------------------------------------------------------------------F
C
C---- Declarations
      INTEGER IUNIT
C
C---- Output formats
1000  FORMAT(A)
C
      WRITE(IUNIT,1000) CHAR(12)
      RETURN
      END
C
C
C
      SUBROUTINE MOVE CURSOR(ROW,COL)
C
C**********************************************************************S
C
C  PURPOSE: To move cursor to a specifc screen position.
C
C  ARGUMENT(S):
C  Argument  Type  I/O  Description and valid value range
C  --------  ----  ---  ------------------------------------------------
C  ROW       I*4    I   The row to which the cursor is to be moved
C                       (1 to 25).
C  COL       I*4    I   The column to which the cursor is to be moved
C                       (1 to 80)
C
C**********************************************************************F
C
      INTEGER*4 ROW,COL,LENCHR
      CHARACTER ESC*1,STRING*8
2000  FORMAT(' ',A)
C
      ESC = CHAR(27)
      STRING = ESC//'[##;##H'
      WRITE(STRING(3:4),'(I2)') ROW
      WRITE(STRING(6:7),'(I2)') COL
      CALL STRIM(STRING)
      WRITE(*,2000) STRING(1:LENCHR(STRING))
C
      RETURN
      END
C
C
C
      SUBROUTINE UP CURSOR(ROWS)
C
C**********************************************************************S
C
C  PURPOSE: To move the cursor up from its current position by the
C           number of specified rows.
C
C  ARGUMENT(S):
C  Argument  Type  I/O  Description and valid value range
C  --------  ----  ---  ------------------------------------------------
C  ROWS      I*4    I   Number of rows the cursor is to be moved
C                       (1 to 24).
C
C**********************************************************************F
C
      INTEGER*4 ROWS,LENCHR
      CHARACTER ESC*1,STRING*5
2000  FORMAT(' ',A)
C
      ESC = CHAR(27)
      STRING = ESC//'[##A'
      WRITE(STRING(3:4),'(I2)') ROWS
      CALL STRIM(STRING)
      WRITE(*,2000) STRING(1:LENCHR(STRING))
C
      RETURN
      END
C
C
C
      SUBROUTINE DOWN CURSOR(ROWS)
C
C**********************************************************************S
C
C  PURPOSE: To move the cursor down from its current position by the
C           number of specified rows.
C
C  ARGUMENT(S):
C  Argument  Type  I/O  Description and valid value range
C  --------  ----  ---  ------------------------------------------------
C  ROWS      I*4    I   Number of rows the cursor is to be moved
C                       (1 to 24).
C
C**********************************************************************F
C
      INTEGER*4 ROWS,LENCHR
      CHARACTER ESC*1,STRING*5
2000  FORMAT(' ',A)
C
      ESC = CHAR(27)
      STRING = ESC//'[##B'
      WRITE(STRING(3:4),'(I2)') ROWS
      CALL STRIM(STRING)
      WRITE(*,2000) STRING(1:LENCHR(STRING))
C
      RETURN
      END
C
C
C
      SUBROUTINE RIGHT CURSOR(COLS)
C
C**********************************************************************S
C
C  PURPOSE: To move the cursor to the right from its current position
C           by the number of specified columns.
C
C  ARGUMENT(S):
C  Argument  Type  I/O  Description and valid value range
C  --------  ----  ---  ------------------------------------------------
C  COLS      I*4    I   Number of columns the cursor is to be moved
C                       (1 to 79).
C
C**********************************************************************F
C
      INTEGER*4 COLS,LENCHR
      CHARACTER ESC*1,STRING*5
2000  FORMAT(' ',A)
C
      ESC = CHAR(27)
      STRING = ESC//'[##C'
      WRITE(STRING(3:4),'(I2)') COLS
      CALL STRIM(STRING)
      WRITE(*,2000) STRING(1:LENCHR(STRING))
C
      RETURN
      END
C
C
C
      SUBROUTINE LEFT CURSOR(COLS)
C
C**********************************************************************S
C
C  PURPOSE: To move the cursor to the left from its current position
C           by the number of specified columns.
C
C  ARGUMENT(S):
C  Argument  Type  I/O  Description and valid value range
C  --------  ----  ---  ------------------------------------------------
C  COLS      I*4    I   Number of columns the cursor is to be moved
C                       (1 to 79).
C
C**********************************************************************F
C
      INTEGER*4 COLS,LENCHR
      CHARACTER ESC*1,STRING*5
2000  FORMAT(' ',A)
C
      ESC = CHAR(27)
      STRING = ESC//'[##D'
      WRITE(STRING(3:4),'(I2)') COLS
      CALL STRIM(STRING)
      WRITE(*,2000) STRING(1:LENCHR(STRING))
C
      RETURN
      END
C
C
C
      SUBROUTINE SAVE CURSOR
C
C**********************************************************************S
C
C  PURPOSE: To save the current row and column position of the cursor.
C           The cursor can be moved to this position later by a call to
C           the RESTORE CURSOR subroutine.
C
C  ARGUMENT(S):
C  Argument  Type  I/O  Description and valid value range
C  --------  ----  ---  ------------------------------------------------
C  NONE
C
C**********************************************************************F
C
      CHARACTER ESC*1,STRING*3
2000  FORMAT(' ',A)
C
      ESC = CHAR(27)
      STRING = ESC//'[s'
      WRITE(*,2000) STRING
C
      RETURN
      END
C
C
C
      SUBROUTINE RESTORE CURSOR
C
C**********************************************************************S
C
C  PURPOSE: To move the cursor to the row and column position most
C           recently saved by a call to the SAVE CURSOR subroutine.
C
C  ARGUMENT(S):
C  Argument  Type  I/O  Description and valid value range
C  --------  ----  ---  ------------------------------------------------
C  NONE
C
C**********************************************************************F
C
      CHARACTER ESC*1,STRING*3
2000  FORMAT(' ',A)
C
      ESC = CHAR(27)
      STRING = ESC//'[u'
      WRITE(*,2000) STRING
C
      RETURN
      END
C
C
C
      SUBROUTINE ERASE DISPLAY
C
C**********************************************************************S
C
C  PURPOSE: To erase the entire display and position the cursor at the
C           home position (equivalent to the MS-DOS Clear Screen, or
C           CLS command).
C
C  ARGUMENT(S):
C  Argument  Type  I/O  Description and valid value range
C  --------  ----  ---  ------------------------------------------------
C  NONE
C
C**********************************************************************F
C
      CHARACTER ESC*1,STRING*4
2000  FORMAT(' ',A)
C
      ESC = CHAR(27)
      STRING = ESC//'[2J'
      WRITE(*,2000) STRING
C
      RETURN
      END
C
C
C
      SUBROUTINE ERASE LINE
C
C**********************************************************************S
C
C  PURPOSE: To erase a line from the current cursor position to the end
C           of the line, including the cursor position.
C
C  ARGUMENT(S):
C  Argument  Type  I/O  Description and valid value range
C  --------  ----  ---  ------------------------------------------------
C  NONE
C
C**********************************************************************F
C
      CHARACTER ESC*1,STRING*4
2000  FORMAT(' ',A)
C
      ESC = CHAR(27)
      STRING = ESC//'[2J'
      WRITE(*,2000) STRING
C
      RETURN
      END
C
C
C
      SUBROUTINE SET ATTRIBUTE(ATTR)
C
C**********************************************************************S
C
C  PURPOSE: To turn on a characteristic, or attribute, of the screen
C           display.
C
C  ARGUMENT(S):
C  Argument  Type  I/O  Description and valid value range
C  --------  ----  ---  ------------------------------------------------
C  ATTR      I*4    I   Display attribute parameter defined below:
C
C                       ATTR  Screen display attribute
C                       ====  ==========================================
C                         0   None. All attributes off (default = white
C                             characters on black background).
C                         1   High intensity (bold face).
C                         4   Underline (monochrome only).
C                         5   Blinking (flashing).
C                         7   Reverse video (black-on-white).
C                         8   Invisible display (black-on-black).
C                        30   Foreground black.
C                        31   Foreground red.
C                        32   Foreground green.
C                        33   Foreground yellow.
C                        34   Foreground blue.
C                        35   Foreground magenta.
C                        36   Foreground cyan.
C                        37   Foreground white.
C                        40   Background black.
C                        41   Background red.
C                        42   Background green.
C                        43   Background yellow.
C                        44   Background blue.
C                        45   Background magenta.
C                        46   Background cyan.
C                        47   Background white.
C
C**********************************************************************F
C
      INTEGER*4 ATTR,LENCHR
      CHARACTER ESC*1,STRING*5
2000  FORMAT(' ',A)
C
      ESC = CHAR(27)
      STRING = ESC//'[##m'
      WRITE(STRING(3:4),'(I2)') ATTR
      CALL STRIM(STRING)
      WRITE(*,2000) STRING(1:LENCHR(STRING))
C
      RETURN
      END
C
C
C
      SUBROUTINE SET MODE(MODE)
C
C**********************************************************************S
C
C  PURPOSE: To set the operating mode of the screen display.  This
C           subroutine can be used to set the width and color of the
C           screen display, and to turn on line wrap.
C
C  ARGUMENT(S):
C  Argument  Type  I/O  Description and valid value range
C  --------  ----  ---  ------------------------------------------------
C  MODE      I*4    I   Display mode parameter defined below:
C
C                       MODE  Screen display mode
C                       ====  ==========================================
C                         0   40 columns by 25 rows, monochrome.
C                         1   40 columns by 25 rows, color.
C                         2   80 columns by 25 rows, monochrome.
C                         3   80 columns by 25 rows, color.
C                         4   320 by 200 graphics, color.
C                         5   320 by 200 graphics, monochrome.
C                         6   640 by 200 graphics, monochrome.
C                         7   Turn on line wrap.
C
C**********************************************************************F
C
      INTEGER*4 MODE,LENCHR
      CHARACTER ESC*1,STRING*6
2000  FORMAT(' ',A)
C
      ESC = CHAR(27)
      STRING = ESC//'[=##h'
      WRITE(STRING(4:5),'(I2)') MODE
      CALL STRIM(STRING)
      WRITE(*,2000) STRING(1:LENCHR(STRING))
C
      RETURN
      END
C
C
C
      SUBROUTINE WRAP ON
C
C**********************************************************************S
C
C  PURPOSE: To turn on (enable) line wrap.  Causes lines longer than 80
C           characters to be broken at the 80th character and continued
C           on the next line.
C
C  ARGUMENT(S):
C  Argument  Type  I/O  Description and valid value range
C  --------  ----  ---  ------------------------------------------------
C  NONE
C
C**********************************************************************F
C
      CHARACTER ESC*1,STRING*5
2000  FORMAT(' ',A)
C
      ESC = CHAR(27)
      STRING = ESC//'[=7h'
      WRITE(*,2000) STRING
C
      RETURN
      END
C
C
C
      SUBROUTINE WRAP OFF
C
C**********************************************************************S
C
C  PURPOSE: To turn off (disable) line wrap.  Causes lines longer than
C           80 characters to be truncated at the 80th character and not
C           continued on the next line (that is, typing past end-of-line
C           does not cause a carraige return to be issued automatically)
C
C  ARGUMENT(S):
C  Argument  Type  I/O  Description and valid value range
C  --------  ----  ---  ------------------------------------------------
C  NONE
C
C**********************************************************************F
C
      CHARACTER ESC*1,STRING*5
2000  FORMAT(' ',A)
C
      ESC = CHAR(27)
      STRING = ESC//'[=7l'
      WRITE(*,2000) STRING
C
      RETURN
      END
C
C
C
      SUBROUTINE KEY DEFINE(KEY,RESULT)
C
C**********************************************************************S
C
C  PURPOSE: To assign one or more characters to be produced when a
C           single key or a combination of two keys is pressed.
C
C  ARGUMENT(S):
C  Argument  Type  I/O  Description and valid value range
C  --------  ----  ---  ------------------------------------------------
C  KEY       CHAR   I   Key code that specifies the key to be defined.
C                       If the key to be defined is one of the standard
C                       ASCII characters, KEY is a number from 1 to 127.
C                       that is the ANSI.SYS key code for that key.  If
C                       the key to be defined is a function key, a
C                       keypad key, or a combination of the Shift, Ctrl,
C                       or Alt key and some other key, KEY is two
C                       numbers separated by a semicolon.  The first
C                       number is always 0, and the second number is
C                       the ANSI.SYS extended key code for that key or
C                       key combination.
C
C  RESULT    CHAR       The character or characters to be produced when
C                       a key or a key combination is pressed.  It can
C                       be specified as an ASCII code, an extended key
C                       code, or a string enclosed in quatation marks.
C                       To restore a key to its original meaning, set
C                       RESULT equal to KEY.
C
C**********************************************************************F
C
C---- Declarations (arguments)
      CHARACTER KEY*(*),RESULT*(*)
C
C---- Declarations (local)
      INTEGER   I,L,LENCHR
      CHARACTER STRING*256
C
C---- Output formats
2000  FORMAT(' ',A)
C
      STRING(1:1)=CHAR(27)
      I=LENCHR(KEY)
      L=I+1
      STRING(2:L)=KEY(1:I)
      L=L+1
      STRING(L:L)=';'
      I=LENCHR(RESULT)
      STRING(L+1:L+I)=RESULT
      L=L+I+1
      STRING(L:L)='p'
      WRITE(*,2000) STRING(1:L)
C
      RETURN
      END
C
C
C
      SUBROUTINE KEY RESTORE(KEY)
C
C**********************************************************************S
C
C  PURPOSE: To restore a key to its original meaning after it has been
C           redefined by a call to subroutine KEY DEFINE.
C
C  ARGUMENT(S):
C  Argument  Type  I/O  Description and valid value range
C  --------  ----  ---  ------------------------------------------------
C  KEY       CHAR   I   Key code that specifies the key to be restored.
C                       If the key to be restored is one of the standard
C                       ASCII characters, KEY is a number from 1 to 127.
C                       that is the ANSI.SYS key code for that key.  If
C                       the key to be restored is a function key, a
C                       keypad key, or a combination of the Shift, Ctrl,
C                       or Alt key and some other key, KEY is two
C                       numbers separated by a semicolon.  The first
C                       number is always 0, and the second number is
C                       the ANSI.SYS extended key code for that key or
C                       key combination.
C
C**********************************************************************F
C
C---- Declarations (arguments)
      CHARACTER KEY*(*)
C
C---- Declarations (local)
      INTEGER   I,L,LENCHR
      CHARACTER STRING*256
C
C---- Output formats
2000  FORMAT(' ',A)
C
      STRING(1:1)=CHAR(27)
      I=LENCHR(KEY)
      L=I+1
      STRING(2:L)=KEY(1:I)
      L=L+1
      STRING(L:L)=';'
      STRING(L+1:L+I)=KEY
      L=L+I+1
      STRING(L:L)='p'
      WRITE(*,2000) STRING(1:L)
C
      RETURN
      END
C
C
C
      SUBROUTINE FMTWRT(STRING)
C
C**********************************************************************S
C
C  PURPOSE: To write a string using a language-dependent format
C           statement.
C
C  ARGUMENT(S):
C  Argument  Type  I/O  Description and valid value range
C  --------  ----  ---  ------------------------------------------------
C  STRING    CHAR   I   Character string to be writen.
C
C**********************************************************************F
C
      CHARACTER STRING*(*)
2000  FORMAT(' ',A)
C
      WRITE(*,2000) STRING(1:LEN(STRING))
C
      RETURN
      END
C
C
C
      SUBROUTINE STRIM(STRING)
C
C**********************************************************************S
C
C  PURPOSE: To remove embeded blanks between substrings in a character.
C           string
C
C  ARGUMENT(S):
C  Argument  Type  I/O  Description and valid value range
C  --------  ----  ---  ------------------------------------------------
C  STRING    CHAR   I   The character string from which embedded blanks
C                       are to be remove.
C                   O   Blank-removed STRING
C
C**********************************************************************F
C
      INTEGER*4 I,J
      CHARACTER STRING*(*),TEMP*256
C
      J = 0
      DO 100 I = 1, LEN(STRING)
        IF(STRING(I:I) .NE. ' ') THEN
        J = J + 1
        TEMP(J:J) = STRING(I:I)
      ENDIF
100   CONTINUE
      IF(J.GT.0) STRING = TEMP(1:J)
C
      RETURN
      END
