CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   gksetplt
C
C   Purpose:  This routine, called by subroutine PLOTS, initializes
C   user-defined variables for GKS plotting.  These are stored in
C   a .CFG file which should exist in the same directory as the executable
C   file being run.  The user is asked whether or not to modify the
C   plotting parameters.  If the user answers yes, or if the appropriate
C   .CFG file does not exist or is incomplete, the user is then prompted
C   for all the variables.  A blank carriage return in response to any
C   question retains the previous value, unless the previous value
C   did not exist.
C
C---- Arguments:  None.
C
      SUBROUTINE GKSETPLT
C
      INCLUDE 'digsblk.cmn'
C
C     + + + LOCAL VARIABLES + + +
      REAL ary(8)
      INTEGER cfgunit, cdev, i, iflg, retcod, isclu, j, len, nop, isgrp, 
     &        iret, icmd, ifmt, mxsel(1), mnsel(1), lenop, iopval(1), 
     &        iary(23), numi, numr, itype(9)
      LOGICAL fopened
      CHARACTER appnam*8, wndnam*34, fname*64, cfgfile*14
C
C     + + + EXTERNALS + + +
      EXTERNAL ANINIZ, ZANSET, ZSTCMA, OPNSEQ, Q1INIT, QSETOP, QSETI, 
     &         QSETR, Q1EDIT, QGETOP, QGETI, QGETR, DGSETWS, QSTCTF,
     &         DGSETOUTFILE, QGTCTF, ANCLOS
C
C     + + + INTRINSICS + + +
      REAL FLOAT
      INTEGER IFIX
      INTRINSIC FLOAT, IFIX
C
C     + + + DATA + + +
      DATA itype/24, 25, 26, 1100, 1101, 7475, 101, 101, 100/
C
C---Set default values for .cfg file:
C---Mode -- GKS software type
C---1=Prior GKS, 2=DISSPLA GKS, 3=GSS-GKS, 4=XGKS, 5=other
      Mode = 1
      cdev = 1
      Bgclr = 0
      Mark = 0
      Font = 1
      Fntprec = 2
      DO 10 i = 1, 9
        Linecolor(i) = i
        Linetype(i) = 1
   10 CONTINUE
      Linetype(2) = 2
      Linetype(3) = 3
      Xpage = 50.0
      Ypage = 50.0
      Pxoff = 0.5
      Pyoff = 0.5
      Irotate = 0
      Pltfact = 1.0
      Plinefact = 1.0
      Facmrk = 1.0
      Numws = 2
      DO 20 i = 3, 5
        Device(i) = 0
        Conid(i) = 0
        Wtype(i) = 0
        Filenm(i) = ' '
        Fileout(i) = 0
   20 CONTINUE
      Device(1) = 1
      Conid(1) = -32768
      Wtype(1) = 1100
      Filenm(1) = ' '
      Device(2) = 2
      Conid(2) = 1
      Wtype(2) = 100
      Filenm(2) = 'pscript.dpo '
      Fileout(2) = 1
C
C---Select the appropriate .CFG file:
      cfgfile = 'DIGSPLT.CFG'
      IF (Cfg.GT.0 .AND. Cfg.LT.10) WRITE (cfgfile,9030) Cfg
      IF (Cfg.GT.9 .AND. Cfg.LT.100) WRITE (cfgfile,9035) Cfg
C
C---Find an unopened file unit:
      DO 50 cfgunit = 30, 100
        INQUIRE (cfgunit,OPENED=fopened)
        IF (.NOT.fopened) THEN
C
C---Read the .CFG file:
          iflg = 1
          ifmt = 0
          CALL OPNSEQ(cfgunit,cfgfile,iflg,ifmt,retcod)
          IF (retcod.LT.0) STOP '*ERROR opening plot configuration file'
          IF (retcod.EQ.0) THEN
            READ (cfgunit,9005,END=30,ERR=30) Mode, Numws
            READ (cfgunit,9005,END=30,ERR=30) Device
            READ (cfgunit,9005,END=30,ERR=30) Conid
            READ (cfgunit,9005,END=30,ERR=30) Wtype
            READ (cfgunit,9015,END=30,ERR=30) Filenm
            READ (cfgunit,9025,END=30,ERR=30) Xpage, Ypage, Irotate
            READ (cfgunit,9020,END=30,ERR=30) Pxoff, Pyoff, Pltfact, 
     &            Plinefact
            READ (cfgunit,9005,END=30,ERR=30) cdev, Bgclr
            READ (cfgunit,9005,END=30,ERR=30) Linecolor
            READ (cfgunit,9005,END=30,ERR=30) Linetype
            READ (cfgunit,9010,END=30,ERR=30) Mark, Facmrk
            READ (cfgunit,9005,END=30,ERR=30) Font, Fntprec
            GOTO 40
   30       WRITE (99,*) 
     &             '*ERROR* reading plotting config file-verify values.'
   40       CLOSE (cfgunit)
            IF (Facmrk.EQ.0.0) Facmrk = 1.0
            IF (Plinefact.EQ.0.0) Plinefact = 1.0
            IF (Pltfact.EQ.0.0) Pltfact = 1.0
          ENDIF
          GOTO 60
        ENDIF
   50 CONTINUE
      STOP 'no available Fortran unit number'
C
C---name of application, log file, and message file
   60 iflg = 0
      ifmt = 0
      CALL OPNSEQ(cfgunit,'DIGSmsg.FIL',iflg,ifmt,iret)
      IF (iret.NE.0) GOTO 170
      READ (cfgunit,'(A)',END=170) fname
      CLOSE (cfgunit)
C
C---Open message file and log file
      Messfl = 9
      appnam = 'DIGS  '
      CALL ANINIZ(Messfl,fname,appnam)
C
C---Set application name
      wndnam = 'Device Independent Graphics System'
      CALL ZANSET(wndnam)
C
C---Disable Xpad
      icmd = 21
      iflg = 0
      CALL ZSTCMA(icmd,iflg)
C
C---Display opening screen
   70 isclu = 101
      isgrp = 1
      CALL Q1INIT(Messfl,isclu,isgrp)
C
C---Set option field
      nop = 1
      lenop = 1
      mxsel(1) = 1
      mnsel(1) = 1
      iopval(1) = 1
      CALL QSETOP(nop,lenop,mxsel,mnsel,iopval)
C
C---Initialize integer plot options
      numi = 22
c     iary(1) = Mode
      iary(1) = Bgclr
      iary(2) = Mark
      iary(3) = Font
      iary(4) = Fntprec
      DO 80 i = 1, 9
        iary(i+4) = Linecolor(i)
        iary(i+13) = Linetype(i)
   80 CONTINUE
      CALL QSETI(numi,iary)
C
C---Initialize real plot options
      numr = 8
      ary(1) = Xpage
      ary(2) = Ypage
      ary(3) = Pxoff
      ary(4) = Pyoff
      ary(5) = FLOAT(Irotate)
      ary(6) = Pltfact
      ary(7) = Plinefact
      ary(8) = Facmrk
      CALL QSETR(numr,ary)
C
C---Edit the screen
C---iret: 1=accept, 2=prev, -1=oops
      CALL Q1EDIT(iret)
C
C---Oops, try again
      IF (iret.EQ.-1) GOTO 70
C
C---User wants to continue, set values
C---Get option fields
      CALL QGETOP(lenop,iopval)
C
C---Get integer data fields
      CALL QGETI(numi,iary)
c     Mode = iary(1)
      Bgclr = iary(1)
      Mark = iary(2)
      Font = iary(3)
      Fntprec = iary(4)
      DO 90 i = 1, 9
        Linecolor(i) = iary(i+4)
        Linetype(i) = iary(i+13)
   90 CONTINUE
C
C---Get real data fields
      CALL QGETR(numr,ary)
      Xpage = ary(1)
      Ypage = ary(2)
      Pxoff = ary(3)
      Pyoff = ary(4)
      Irotate = IFIX(ary(5))
      IF (Irotate.NE.0) THEN
        IF (Pxoff.EQ.0.0) Pxoff = -6.0
        IF (Pyoff.EQ.0.0) Pyoff = -6.0
      ENDIF
      Pltfact = ary(6)
      Plinefact = ary(7)
      Facmrk = ary(8)
C
C---determine the number of WS
      Numws = 0
      numi = 5
      DO 110 j = 1, numi
        DO 100 i = 1, 9
          IF (Wtype(j).EQ.itype(i)) THEN
            Wstype(j) = i
            Numws = Numws + 1
            GOTO 110
          ENDIF
  100   CONTINUE
        Wstype(j) = 0
  110 CONTINUE
      CALL DGSETWS(Mode,Numws,Device,Wtype,Conid)
      CALL DGSETOUTFILE(Conid,Wtype,Filenm)
      IF (iopval(1).EQ.1) THEN
C
C---Display opening screen
  120   isgrp = 11
        CALL Q1INIT(Messfl,isclu,isgrp)
C
C---Initialize integer plot options
        CALL QSETI(numi,Wstype)
C
C---Initialize plotter output file names
        len = 36
        DO 130 i = 1, 5
          CALL QSTCTF(i,len,Filenm(i))
  130   CONTINUE
C
C---Edit the screen
C---iret: 1=accept, 2=prev, -1=oops
        CALL Q1EDIT(iret)
C
C---Oops, try again
        IF (iret.EQ.-1) GOTO 120
C
C---User wants to continue, set values
C---Get integer data fields
        CALL QGETI(numi,Wstype)
C
C---Get plotter output file names
        DO 140 i = 1, 5
          CALL QGTCTF(i,len,Filenm(i))
  140   CONTINUE
      ENDIF
C
C---Determine number of WS and connection ID'S and device numbers
      Numws = 0
      DO 150 j = 1, numi
        IF (Wstype(j).GT.0) THEN
          Wtype(j) = itype(Wstype(j))
          Numws = Numws + 1
        ENDIF
  150 CONTINUE
      CALL DGSETWS(Mode,Numws,Device,Wtype,Conid)
      CALL DGSETOUTFILE(Conid,Wtype,Filenm)
C
C---Write the the .CFG file:
      iflg = 1
      ifmt = 0
      CALL OPNSEQ(cfgunit,cfgfile,iflg,ifmt,retcod)
      WRITE (cfgunit,9040) Mode, Numws, Device, Conid, Wtype, Filenm, 
     &                     Xpage, Ypage, Irotate, Pxoff, Pyoff, Pltfact, 
     &                     Plinefact, cdev, Bgclr, Linecolor, Linetype, 
     &                     Mark, Facmrk, Font, Fntprec
      CLOSE (cfgunit)
      Colordev = .FALSE.
      IF (cdev.EQ.1) Colordev = .TRUE.
C
C---Close message, scratch and log files
  160 CALL ANCLOS(Messfl)
      RETURN
C
  170 WRITE (99,9045)
      STOP
C
C---Read/Write formats:
 9005 FORMAT (20X,9I6)
 9010 FORMAT (20X,I6,F6.2)
 9015 FORMAT (20X,9A16)
 9020 FORMAT (20X,4F6.2)
 9025 FORMAT (20X,2F6.2,I6)
 9030 FORMAT ('DIGSPLT',I1,'.CFG')
 9035 FORMAT ('DIGSPLT',I2,'.CFG')
 9040 FORMAT (' GKS type/no. of WS ',2I6,/' Workstation ids    ',5I6,/,
     &        ' WS connection ids  ',5I6,/' Workstation types  ',5I6,/,
     &        ' Output file names  ',5A16,/' Page size/orient   ',2F6.2,
     &        I6,/,' Offset/scale/linwid',4F6.2,/,
     &        ' Color device/backgr',2I6,/' Line colors        ',9I6,/,
     &        ' Line styles        ',9I6,/' Marker symbol/fact ',I6,
     &        F6.2,/,' Font # & precision ',2I6)
 9045 FORMAT (/,' **Error** opening DIGS message file',/,11X,
     &        'The DIGSmsg.FIL file must be in current directory.',/,
     &        11X,' Be sure to use the supplied SWAMI script program.')
      END
C
C
C
      SUBROUTINE DGSETOUTFILE(CONID,WTYPE,FILENM)
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER WTYPE(5), CONID(5)
      CHARACTER*36 FILENM(5)
C
C     + + + LOCAL VARIABLES + + +
      INTEGER i, j, k
      CHARACTER*1 suffix, chr
C
C     + + + EXTERNALS + + +
      INTEGER LENCHR
      EXTERNAL LENCHR
C
C     + + + END SPECIFICATIONS + + +
C
      DO 20 i = 1, 5
        IF (CONID(i).NE.1) THEN
          FILENM(i) = '      '
        ELSEIF (FILENM(i).EQ.' ') THEN
          IF (WTYPE(i).EQ.24) FILENM(i) = 'cgmbin.dpo'
          IF (WTYPE(i).EQ.25) FILENM(i) = 'cgmtxt.dpo'
          IF (WTYPE(i).EQ.26) FILENM(i) = 'cgmchr.dpo'
          IF (WTYPE(i).EQ.7475) FILENM(i) = 'hpgl7475.dpo'
          IF (WTYPE(i).GT.99 .AND. WTYPE(i).LT.103) 
     &        FILENM(i) = 'pscript.dpo'
          DO 10 j = 1, i - 1
            IF (FILENM(j).EQ.FILENM(i)) THEN
              k = LENCHR(FILENM(i))
              READ (FILENM(i)(k:k),9005) chr
              WRITE (suffix,9005) i
              IF (chr.EQ.suffix) WRITE (suffix,9005) i + 1
              FILENM(i)(k:k) = suffix
            ENDIF
   10     CONTINUE
        ENDIF
   20 CONTINUE
      RETURN
 9005 FORMAT (A1)
      END
C
C
C
      SUBROUTINE DGSETWS(MODE,NUMWS,DEVICE,WTYPE,CONID)
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER MODE, DEVICE(*), WTYPE(*), NUMWS, CONID(*)
C
C     + + + LOCAL VARIABLES + + +
      INTEGER i
C
C     + + + END SPECIFICATIONS + + +
C
C---Determine workstation device type(s) to open:
      DO 10 i = 1, NUMWS
        IF (MODE.EQ.3) THEN
          DEVICE(i) = WTYPE(i)
        ELSE
          DEVICE(i) = i
        ENDIF
   10 CONTINUE
      DO 20 i = 1, NUMWS
        IF (MODE.EQ.3) THEN
          CONID(i) = 0
        ELSE
          CONID(i) = 1
          IF (MODE.EQ.1) THEN
            IF (WTYPE(i).EQ.1100) CONID(i) = -32768
            IF (WTYPE(i).EQ.1101) CONID(i) = -32768
            IF (WTYPE(i).EQ.1) CONID(i) = -32768
C         ELSE
C           WRITE (99,9030)
          ENDIF
        ENDIF
   20 CONTINUE
      RETURN
C9015 FORMAT (' Supported CA-GKS/DISSPLA devices and workstation type nu
C    &mbers are:',//,
C    &' DEC VT241 (Regis): 9014   TEK 4006: 9005      TEK 4016: 9006'/
C    &' HP 2623:           9010   TEK 4010,4012,4013,4051:      9001'/
C    &' HP 2647, 2648:     9011   TEK 4014,4015,4052,4054,4081: 9002'/
C    &' HP 7475A:          9012   TEK 4025: 9003      TEK 4027: 9004'/
C    &' IBM 3179:          3179   TEK 4106,4107,4109,4115,4125: 4107'/
C    &' IBM 3270 PC/G:     5279   TEK 4112: 4112      TEK 4113: 4113'/
C    &' IBM 3270 PC/GX:    5379   TEK 4114, 4116:               4114'/
C    &' IBM 3279:          3279   TEK 4226: 9008      TEK 4663: 9009'/
C    &' ISSCO-GKS DISSPOP Metafile:'/
C    &' For software characters and area fill: 102'/
C    &' For hardware characters and area fill: 103'/
C    &' ISSCO-GKS Output Metafile:             1')
C9020 FORMAT (' Supported GSS*GKS devices on a PC are:',//,2X,
C    &        2(2X,'Code',5X,'Device Type'),8X,'Code',5X,'Device Type',
C    &        /,6X,
C    &'0  --  WISS           4  --  Input GKS metafile   7  --  Plotter'
C    &,/,6X,
C    &'1  --  Terminal       5  --  Output GKS metafile  8  --  Output C
C    &GM',/,6X,'2,3 -  Input devices  6  --  Printer')
C9030 FORMAT (/
C    &' A connection id must be specified for each workstation that is t
C    &o be opened.',/,
C    &' For example, the connection id for an X11 window is -32768 or NU
C    &LL, for others',/,
C    &' it may be 0.  If the workstation produces an output file such as
C    & a CGM or',/,
C    &' PostScript file, enter 1 to the id query.  For NCAR GKS, enter 2
C    &.  For XGKS,',/,' enter 5 for an X window and 1 for a CGM file.')
C9040 FORMAT (/,
C    &       ' For XGKS, enter 4 for an X window and 2 for a CGM file.')
C9045 FORMAT (/,' For NCAR GKS, enter 1, for others please supply type n
C    &umbers as appropriate.')
      END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  opndigs
C
C  Purpose:  Opens the GKS system, opens and activates all
C            requested workstations, and sets the maximum viewable area
C            for all devices.  Called by subroutines PLOTS and PLOT.
C
C  Arguments:  None.
C
C  GKS subroutines used:
C
C      Control Functions:
C
C         Subroutine gacwk (wkid):     Activate workstation.
C                                      Integer wkid:  Workstation identifier.
C
C         Subroutine gopks (errfil, size):  Open GKS.
C                                      Integer errfil:  Error message file:
C                                         A logical unit number from a
C                                         standard FORTRAN OPEN statement,
C                                         which must be opened prior to
C                                         this call.
C                                      Integer size:  Size of a buffer area
C                                         in words allocated for use by
C                                         workstation-independent
C                                         segment storage.
C
C         Subroutine gopwk (wkid, conid, wtype):  Open workstation.
C                                      Integer wkid:  Workstation identifier.
C                                      Integer conid: Connection identifier
C                                         (not used with GSS*GKS on PCs).
C                                      Integer wtype: Workstation type
C                                         (same as wkid in GSS*GKS;
C                                         defined by the files KERNEL.SYS
C                                         and CGI.CFG).
C
C      Attribute Functions:
C
C         Subroutine gstxfp (font, Fntprec):  Set text font and precision.
C                                      Integer font:  Text font
C                                         (device-specific).
C                                      Integer Fntprec:  Text precision:
C                                         0 = String fnt_precision, low
C                                         1 = Character fnt_precision, medium
C                                         2 = Stroke fnt_precision. high
C
C      Transformation Functions:
C
C         Subroutine gswn (tnr, xmin, xmax, ymin, ymax):  Set window.
C               Input arguments:
C                                   Integer tnr:  Transformation number.
C                                   Real xmin, xmax, ymin, ymax:
C                                      Window limits in NDC units
C                                      (lower left, upper right).
C
C         Subroutine gsvp (tnr, xmin, xmax, ymin, ymax):  Set viewport.
C               Input arguments:
C                                   Integer tnr:  Transformation number.
C                                   Real xmin, xmax, ymin, ymax:
C                                      Viewport limits (lower-left,
C                                      upper-right) in normalized device
C                                      coordinate (NDC) units.
C
C         Subroutine gswkwn (wkid, xmin, xmax, ymin, ymax):
C               Input arguments:
C                                   Set workstation window.
C                                   Integer wkid:  Workstation identifier.
C                                   Real xmin, xmax, ymin, ymax:
C                                      Workstation window limits in NDC
C                                      units (lower left, upper right).
C
C         Subroutine gsclip (clsw): Set clipping indicator.
C               Input argument:
C                                   Integer clsw:  Clipping indicator:
C                                      0 = No clip,
C                                      1 = Clip.
C
C         Subroutine gselnt (tnr):  Set normalization transformation.
C               Input argument:
C                                   Integer tnr:  Normalization
C                                      transformation number.
C
      SUBROUTINE OPNDIGS()
C
      INCLUDE 'digsblk.cmn'
C
C Declarations (local variables):
C
      LOGICAL fopened, otopen, exists
      INTEGER i, iconid, j, k, iret, iflg, ifmt
      INTEGER iclcap, idcunt, ierrin, lxx, lyy, ncol, ndef
      REAL rxx, ryy, scale, tmp, wsasp, xndc, xwc, yndc, ywc
      CHARACTER otnam*36, ctmp*4, erfil*12
      EXTERNAL OPNSEQ, GOPKS, GOPWK, GACWK, GSCLIP, GSTXFP, GSLWSC,
     &        GSDS, GQCF, CLRTBL, GQDSP, GSWN, GSVP, GSWKWN, GSWKVP, 
     &        GCRSG, GSVIS, GSELNT, GSMK, GSMKSC
      REAL AMAX1
      INTEGER MOD
      INTRINSIC AMAX1, MOD
C
      IF (Isessn.EQ.1) THEN
        erfil = 'GKS.errors  '
C
C Find an unopened file unit:
C
        DO 10 Errunit = 70, 100
          INQUIRE (Errunit,OPENED=fopened)
          IF (.NOT.fopened) GOTO 20
   10   CONTINUE
C
C Open Graphic Kernel System for business:
C
        iflg = 1
        ifmt = 0
   20   CALL OPNSEQ(Errunit,erfil,1,0,iret)
        CALL GOPKS(Errunit,1024)
        WRITE (99,*) 'The GKS errors file is named: ', erfil
C---open WISS workstation
        CALL GOPWK(13,-32768,1)
        CALL GACWK(13)
C---Turn off GKS viewport clipping:
        CALL GSCLIP(0)
C---GKS Set text font and fnt_precision:
        IF (Font.EQ.10 .OR. Font.EQ.0) THEN
          CALL GSTXFP(1,Fntprec)
        ELSE
          CALL GSTXFP(Font,Fntprec)
        ENDIF
C---Set polyline width to PLINEFACT (orig. set to 1.5)
        CALL GSLWSC(Plinefact)
      ENDIF
C
C---Open workstations:
      otopen = .TRUE.
      DO 60 i = 1, Numws
        iconid = Conid(i)
        IF (iconid.EQ.1 .AND. Isessn.EQ.1) THEN
          IF (Filenm(i).EQ.'  ') THEN
            otnam = 'GKSOUT.    '
            WRITE (ctmp,'(I4)') Wtype(i)
            j = 8
            DO 30 k = 1, 4
              IF (ctmp(k:k).NE.' ') THEN
                otnam(j:j) = ctmp(k:k)
                j = j + 1
              ENDIF
   30       CONTINUE
          ELSE
            otnam = Filenm(i)
          ENDIF
          IF (Otunit.GT.6 .AND. otopen) THEN
            iconid = Otunit
            otopen = .FALSE.
            INQUIRE (iconid,OPENED=fopened)
          ELSE
            DO 40 iconid = 70, 100
              INQUIRE (iconid,OPENED=fopened)
              IF (.NOT.fopened) GOTO 50
   40       CONTINUE
          ENDIF
   50     IF (.NOT.fopened) THEN
            INQUIRE (FILE=otnam,EXIST=exists)
            IF (exists) THEN
              OPEN (iconid,FILE=otnam,STATUS='OLD',FORM='FORMATTED',
     &              ACCESS='SEQUENTIAL')
C Truncate file
              ENDFILE iconid
              REWIND iconid
            ELSE
C Position to last line in file
              OPEN (iconid,FILE=otnam,STATUS='NEW',FORM='FORMATTED',
     &              ACCESS='SEQUENTIAL')
            ENDIF
          ENDIF
          Fileout(i) = iconid
          WRITE (99,*) 'Graphical output can be found in file: ', otnam
        ENDIF
        IF (Wtype(i).EQ.1 .AND. iconid.EQ.2) Fileout(i) = iconid
C Open workstations, if first time in OPNDIGS or X-window
        IF (Isessn.EQ.1 .OR. Fileout(i).EQ.0)
     &      CALL GOPWK(Device(i),iconid,Wtype(i))
C Activate workstations:
        CALL GACWK(Device(i))
C set deferral state to ASAP with implicit regeneration suppressed
        CALL GSDS(Device(i),0,0)
C Index colors:
        CALL GQCF(Wtype(i),ierrin,ncol,iclcap,ndef)
        IF (iclcap.NE.0) CALL CLRTBL(Device(i),Bgclr)
C
C Calculate the aspect ratio of display surface:
C
        CALL GQDSP(Wtype(i),ierrin,idcunt,rxx,ryy,lxx,lyy)
        ywc = Ypage
        xwc = Xpage
        wsasp = rxx/ryy
        IF (Irotate.EQ.1) Irotate = 90
        Irotate = MOD(Irotate,360)
        IF ((Irotate.GT.45 .AND. Irotate.LT.135) .OR. 
     &      (Irotate.LT.-45 .AND. Irotate.GT.-135)) THEN
          tmp = ywc
          ywc = xwc
          xwc = tmp
        ENDIF
C
        IF (ywc*wsasp.LT.xwc) THEN
          ywc = xwc/wsasp
        ELSE
          xwc = ywc*wsasp
        ENDIF
C
        WRITE (99,9005) Device(i), wsasp, xwc, ywc
C
C GKS Set Window (world coordinates), no border:
C
        CALL GSWN(Device(i),0.0,xwc,0.0,ywc)
        scale = AMAX1(xwc,ywc)
        xndc = xwc/scale
        yndc = ywc/scale
C
C GKS Set ViewPort in plotting coordinates:
C
        CALL GSVP(Device(i),0.0,xndc,0.0,yndc)
        Xshift(i) = xndc
C
C GKS Set Workstation window:
C
        CALL GSWKWN(Device(i),0.0,xndc,0.0,yndc)
        CALL GSWKVP(Device(i),0.0,rxx,0.0,ryy)
C       CALL GSWKWN(Device(i),0.0,1.0,0.0,1.0)
C
   60 CONTINUE
C create segment 1
      CALL GCRSG(1)
      CALL GSVIS(1,0)
C Select Normalization Transformation defined above:
      CALL GSELNT(Device(1))
C GKS Set marker type:
      IF (Mark.NE.0 .AND. Mark.NE.256) CALL GSMK(Mark)
C GKS Set marker size scale factor:
      CALL GSMKSC(Facmrk)
C
      RETURN
 9005 FORMAT (/,' Device:',I3,' aspect ratio x to y:',F8.4,/,
     &        ' X dimension (in image units):',F9.4,' Y dimension:',
     &        F9.4,/)
      END
C
C
C
      SUBROUTINE CLRTBL(DEV,BGCLR)
C
C     + + + PURPOSE + + +
C     Defines colors for subsequent calls to subroutine NEWPEN;
C     called by subroutine opngks.
C     Colors are indexed as follows:
C        0:  white
C        1:  black
C        2:  red
C        3:  green
C        4:  blue
C        5:  cyan
C        6:  magenta
C        7:  yellow
C        8:  orange
C        9:  brown
C       10:  violet
C       11:  grey
C       12:  light red
C       13:  light green
C       14:  light blue
C       15:  pink
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER DEV, BGCLR
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DEV   - Workstation number
C
C     + + + LOCAL VARIABLES + + +
      INTEGER j
      REAL rgb(3,16)
C
C     + + + EXTERNALS + + +
      EXTERNAL GSCR
C         Subroutine gscr (wkid, ci, cr, cg, cb):  Set color representation.
C                         Integer wkid:  Workstation identifier.
C                         Integer ci:    Color index.
C                         Real cr, cg, cb:  Red/green/blue intensities.
C
C     + + + DATA + + +
      DATA rgb/1.00, 1.00, 1.00, 0.00, 0.00, 0.00, 1.00, 0.00, 0.00, 
     &     0.00, 1.00, 0.00, 0.00, 0.00, 1.00, 0.00, 1.00, 1.00, 1.00, 
     &     0.00, 1.00, 1.00, 1.00, 0.00, 1.00, 0.50, 0.00, 0.60, 0.30, 
     &     0.10, 0.50, 0.10, 0.67, 0.50, 0.50, 0.50, 1.00, 0.40, 0.40, 
     &     0.40, 1.00, 0.40, 0.40, 0.40, 1.00, 1.00, 0.38, 0.38/
C
C     + + + END SPECIFICATIONS + + +
C
      rgb(1,1) = rgb(1,BGCLR+1)
      rgb(2,1) = rgb(2,BGCLR+1)
      rgb(3,1) = rgb(3,BGCLR+1)
      DO 10 j = 1, 16
        CALL GSCR(DEV,j-1,rgb(1,j),rgb(2,j),rgb(3,j))
   10 CONTINUE
      RETURN
      END
C
C
C
      SUBROUTINE CLSDIGS()
C
C     + + + PURPOSE + + +
C     This subroutine, called by subroutine PLOT when the IPEN
C     argument of subroutine PLOT equals 999, deactivates
C     and closes all open workstations, and closes GKS.
C
      INCLUDE 'digsblk.cmn'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER i, ierr, istate
C
C     + + + EXTERNALS + + +
      EXTERNAL GQOPS, GCLSG, GDSG, GQWKS, GDAWK, GCLWK, GCLKS
C         Subroutine gclks:         Close GKS.
C         Subroutine gclwk (wkid):  Close workstation.
C                                   Integer wkid:  Workstation identifier.
C         Subroutine gdawk (wkid):  Deactivate workstation.
C                                   Integer wkid:  Workstation identifier.
C
C     + + + END SPECIFICATIONS + + +
C
C---Close and  Delete Segment
      CALL GQOPS(istate)
      IF (istate.EQ.4) THEN
        CALL GCLSG()
        CALL GDSG(1)
      ENDIF
C
C---GKS Deactivate Workstation:
      DO 10 i = 1, Numws
        CALL GQWKS(Device(i),ierr,istate)
        IF (istate.EQ.1) CALL GDAWK(Device(i))
   10 CONTINUE
      CALL GQWKS(13,ierr,istate)
      IF (istate.EQ.1) THEN
        CALL GDAWK(13)
        CALL GCLWK(13)
      ENDIF
C
C---GKS Close Workstation:
      DO 20 i = 1, Numws
        CALL GQWKS(Device(i),ierr,istate)
        IF (ierr.NE.25) CALL GCLWK(Device(i))
   20 CONTINUE
C
C---GKS Close GKS:
      CALL GCLKS()
      CLOSE (Errunit)
C---set flag to allow tdds to reopen gks from begining (allows iframe
C---to be set to 0 in PLOTS.
      Mode = 999
      END
C
C
C
      SUBROUTINE ENDPLOT()
C
C     + + + PURPOSE + + +
C     This subroutine, called from subroutine PLOT, beeps to signal
C     the end of screen plotting, and then waits for a carriage
C     return from the user to continue.  Finally, this routine
C     clears the screen in the case of display, or advances the
C     page in the case of a printer or plotter, and deactivates.
C
      INCLUDE 'digsblk.cmn'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER i, ierr, istate
C
C     + + + EXTERNALS + + +
      EXTERNAL UPDATEPLOT, NXTPLOT, GQWKS, GDAWK, GCLWK, GDSG
C         Subroutine gwawk (wkid): Deactive workstation
C            Input arguments:
C            Integer wkid:  Workstation identifier.
C         Subroutine gclwk (wkid):  Close Workstation
C            Integer wkid:  Workstation identifier.
C
C---Update Workstation and wait for continue:
      CALL UPDATEPLOT()
      CALL NXTPLOT()
C
C---GKS deactivate Workstation:
      DO 10 i = 1, Numws
        CALL GQWKS(Device(i),ierr,istate)
        IF (istate.EQ.1) CALL GDAWK(Device(i))
C       if terminal output, close workstation
        IF (Fileout(i).EQ.0) CALL GCLWK(Device(i))
   10 CONTINUE
C
C---Delete Segment
      CALL GDSG(1)
      IF (Mode.EQ.2) PRINT *, '  '
      RETURN
      END
C
C
C
      SUBROUTINE UPDATEPLOT
C
C     + + + PURPOSE + + +
C     This subroutine, called from subroutine PLOT, to be sure
C     all plotting instructions are cleared from buffers.
C
      INCLUDE 'digsblk.cmn'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER i, ierrind, iwkcat
      REAL tout(2,3), angle
      EXTERNAL GCLSG, GSVIS, GEVTM, GSSGT, GUWK, GQWKCA
      REAL FLOAT
      INTRINSIC FLOAT
C         Subroutine guwk (wkid, regfl):  Update Workstation
C            Integer wkid:  Workstation identifier.
C            Integer regfl: Regeneration flag:
C               0 = Postpone,
C               1 = Perform.
C
C---Update Workstation (make sure plotting has finished):
C---wait is set to false if terminal output
C---do not want to wait for a reponse if only outputting to a file.
C---This could cause problems on some machines.
      CALL GCLSG()
      CALL GSVIS(1,1)
      IF (Irotate.NE.0) THEN
        angle = FLOAT(Irotate)*3.1415927/180.0
        CALL GEVTM(0.0,0.0,Xshift(1),0.0,angle,1.0,1.0,1,tout)
        CALL GSSGT(1,tout)
      ENDIF
      Ixw = 0
      DO 10 i = 1, Numws
C
C---Update workstation
        CALL GUWK(Device(i),1)
        CALL GQWKCA(Wtype(i),ierrind,iwkcat)
        IF (Ixw.EQ.0 .AND. ierrind.EQ.0 .AND. iwkcat.EQ.2)
     &      Ixw = Device(i)
   10 CONTINUE
      RETURN
      END
C
C
C
      SUBROUTINE NXTPLOT()
C
C     + + + PURPOSE + + +
C     This subroutine, called from subroutine PLOT, beeps to signal
C     the end of screen plotting, and then waits for a carriage
C     return from the user to continue.  Finally, this routine
C     clears the screen in the case of display, or advances the
C     page in the case of a printer or plotter.
C
      INCLUDE 'digsblk.cmn'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER i, istat, itnr
      REAL px, py
      EXTERNAL GRQLC, GCLRWK
C         Subroutine gclrwk (wkid, cofl):  Clear workstation.
C            Input arguments:
C            Integer wkid:  Workstation identifier.
C            Integer cofl:  Control flag:
C               0 = Conditionally:  The display surface is cleared only if
C                                   an object appears on it.
C               1 = Always:         The display surface is always cleared.
C            If the device is a CRT or a printer-plotter with auto-paper
C            advance, the surface is cleared without any user interaction.
C            If the device is a plotter that does not have auto-paper
C            advance, the user will be prompted to change the paper and
C            then press ENTER.
C
C         Subroutine grqlc (wkid,lcdnr,stat,tnr,px,py) Request Locator
C            Integer wkid:  Workstation identifier.
C            Integer lcdnr: Locator device number.
C            Integer stat:  Status of input request.
C            Integer tnr:   Number of normalization transformations used.
C            Real px:       X-value of locator in world coordinates.
C            Real py:       Y-value of locator in world coordinates.
C
C wait is set to false if terminal output
C do not want to wait for a reponse if only outputting to a file.
C This could cause problems on some machines.
C
C
      IF ((Mode.EQ.1 .OR. Mode.EQ.4) .AND. Ixw.NE.0) THEN
        itnr = 0
        CALL GRQLC(Ixw,1,istat,itnr,px,py)
      ENDIF
C
C GKS Clear Workstation:
C
      DO 10 i = 1, Numws
        IF (Fileout(i).EQ.0) CALL GCLRWK(Device(i),0)
   10 CONTINUE
C
      RETURN
      END
C
C
C
      SUBROUTINE DSETPEN(IPEN,LINETYPE,LASTLTYPE)
C
C     + + + PURPOSE + + +
C     This subroutine, called internally to digsgks, gets the proper index
C     index for line styles and then sets it with a call to GKS routine
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER IPEN, LINETYPE(5), LASTLTYPE
C
C     + + + ARGUMENT DEFINITIONS + + +
C     IPEN   - Calcomp IPEN variable,
C              2          draws solid line from previous current position.
C                         to X,Y, which becomes the new current position.
C              +3         moves current position to X,Y.
C              +4 thru +9 same as +2, but draws with a special line type
C                         chosen by the user in subroutine gkSETPLT.
C              -2 thru -9 same as +IPEN except that a new origin is set at X,Y.
C     LINETYPE  - Array of line type indices.
C     LASTLTYPE - Last line type used.
C
C     + + + LOCAL VARIABLES + + +
      INTEGER indx, ltype
C
C     + + + EXTERNALS + + +
      EXTERNAL GSLN
C         gsln (ltype):  Set linetype.
C                        Integer ltype:  Linetype.
C                        Valid GKS line types are:
C                         <-2 = Device dependent
C                          -2 = Dashed with two dots
C                          -1 = Medium dashed
C                           1 = Solid
C                           2 = Dashed
C                           3 = Dotted
C                           4 = Dashed-Dotted
C                         >=5 = Reserved for future standardization
C
C     + + + INTRINSICS + + +
      INTEGER IABS
      INTRINSIC IABS
C
C     + + + END SPECIFICATIONS + + +
C
      indx = IABS(IPEN) - 1
      IF (indx.GT.1) indx = indx - 1
      IF (indx.GT.9) indx = 1
      ltype = LINETYPE(indx)
      IF (LASTLTYPE.NE.ltype) THEN
        CALL GSLN(ltype)
        LASTLTYPE = ltype
      ENDIF
      RETURN
      END
C
C
C
      SUBROUTINE OPNSEQ(IUNIT,FILNAM,IFLG,IFMT,RETC)
C
C     + + + PURPOSE + + +
C     Open a sequential access file as either formatted or unformatted.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER IUNIT, IFLG, IFMT, RETC
      CHARACTER*(*) FILNAM
C
C     + + + ARGUMENT DEFINITIONS + + +
C     IUNIT  - (IN) The logical file unit number of the file.
C     FILNAM - (IN) The name of the file, with length given from
C              the calling program.
C     IFLG   - (IN) Flag to indicate to open file if it does not
C              already exist.  If iflg=0, open only if file already
C              exists, if iflg=1, open if new or old.
C     IFMT   - (IN) Flag to indicate to open file formatted or
C              unformatted (iflg=0 for formatted, iflg=1 for unformatted)
C     RETC   - Flag to indicate file was opened successfully, if retc=0
C              an existing file was opened successfully, if retc=1 a new
C              file was opened successfully, if retc=-2 an error was
C              encountered opening the file, if retc=-3 an error was
C              encountered inquiring on file name, if retc=-1, a
C              required input file did not exist.
C
C     + + + LOCAL VARIABLES + + +
      LOGICAL exists
C
C     + + + END SPECIFICATIONS + + +
C
      CLOSE (IUNIT)
      INQUIRE (FILE=FILNAM,EXIST=exists,ERR=10)
      IF (exists) THEN
        IF (IFMT.EQ.0) THEN
          OPEN (IUNIT,FILE=FILNAM,STATUS='OLD',FORM='FORMATTED',
     &          ACCESS='SEQUENTIAL',ERR=20)
        ELSE
          OPEN (IUNIT,FILE=FILNAM,STATUS='OLD',FORM='UNFORMATTED',
     &          ACCESS='SEQUENTIAL',ERR=20)
        ENDIF
        RETC = 0
      ELSEIF (IFLG.EQ.0) THEN
        RETC = -1
      ELSE
        IF (IFMT.EQ.0) THEN
          OPEN (IUNIT,FILE=FILNAM,STATUS='NEW',FORM='FORMATTED',
     &          ACCESS='SEQUENTIAL',ERR=20)
        ELSE
          OPEN (IUNIT,FILE=FILNAM,STATUS='NEW',FORM='UNFORMATTED',
     &          ACCESS='SEQUENTIAL',ERR=20)
        ENDIF
        RETC = 1
      ENDIF
      GOTO 30
   10 RETC = -3
      GOTO 30
   20 RETC = -2
   30 RETURN
      END
